import org.junit.Rule;
import org.junit.Test;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.lang.reflect.Constructor;
import java.lang.reflect.Method;

import org.junit.contrib.java.lang.system.StandardOutputStreamLog;
import org.junit.rules.Timeout;

import static org.junit.Assert.assertEquals;

public class Aufgabe3Test {

    @Rule
    public final StandardOutputStreamLog log = new StandardOutputStreamLog();

    @Rule
    public Timeout globalTimeout = new Timeout(100);

    @Test
    public void testOutput() throws Exception {
        Class Game = Class.forName("Game");
        Constructor consGame = Game.getConstructor(String.class, int.class);
        Method add = Game.getDeclaredMethod("add", String.class);
        add.setAccessible(true);
        Method next = Game.getDeclaredMethod("next");
        assertEquals(true, next.getReturnType().equals(String.class));
        next.setAccessible(true);
        Constructor consAufgabe = Aufgabe3.class.getConstructor(String[].class, String[].class, int[].class);
        Method play = Aufgabe3.class.getDeclaredMethod("play", int.class);

        System.out.println();
        System.out.println("Test-Output zu Aufgabe3:");

        String[] testValues = new String[]{
                "",
                "Test-Output zu Aufgabe3:",
                "A ist Sieger von X",
                "",
                "d ist Sieger von z",
                "b ist Sieger von x",
                "a ist Sieger von z",
                "",
                "A ist Sieger von X",
                "C ist Sieger von X",
                "D ist Sieger von Y",
                "B ist Sieger von Z",
                "",
                "P ist Sieger von G",
        };
        StringBuilder testString = new StringBuilder();
        for(String i: testValues) {
            testString.append(i).append(System.lineSeparator());
        }

        Object sz1 = consAufgabe.newInstance(new String[]{"A", "B", "C", "D"}, new String[]{"X", "Y", "Z"}, new int[]{3, 7, 11});
        Object sz2 = consAufgabe.newInstance(new String[]{"a", "b", "c", "d"}, new String[]{"x", "y", "z"}, new int[]{7, 11, 3});
        play.invoke(sz1, 20);
        System.out.println();
        play.invoke(sz2, 30);
        System.out.println();
        play.invoke(sz1, 50);
        System.out.println();

        Object p = consGame.newInstance("G", 2);
        add.invoke(p, "P");
        add.invoke(p, "Q");
        assertEquals(null, next.invoke(p));
        assertEquals("Q", next.invoke(p));
        assertEquals(null, next.invoke(p));
        assertEquals(null, next.invoke(p));

        assertEquals(testString.toString(), log.getLog());
    }

}